package com.hzya.frame.report.lets.service.impl;

import cn.hutool.core.lang.Assert;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.page.PageAttribute;
import com.hzya.frame.report.lets.dao.ITocofsSaleoutDao;
import com.hzya.frame.report.lets.dao.ITocofsSaleoutDetailedDao;
import com.hzya.frame.report.lets.entity.TocofsReturngoodsEntity;
import com.hzya.frame.report.lets.entity.TocofsSaleoutDetailedEntity;
import com.hzya.frame.report.lets.entity.TocofsSaleoutEntity;
import com.hzya.frame.report.lets.service.ITocofsSaleoutService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * root(TocofsSaleout)表服务实现类
 *
 * @author makejava
 * @since 2024-08-01 17:01:32
 */
@Service(value = "tocofsSaleoutServiceImplReport")
public class TocofsSaleoutServiceImpl extends BaseService<TocofsSaleoutEntity, String> implements ITocofsSaleoutService {

    private ITocofsSaleoutDao tocofsSaleoutDao;

    @Autowired
    private ITocofsSaleoutDetailedDao iTocofsSaleoutDetailedDao;

    @Autowired
    public void setTocofsSaleoutDao(ITocofsSaleoutDao dao) {
        this.tocofsSaleoutDao = dao;
        this.dao = dao;
    }

    @Override
    public JsonResultEntity queryToCSalesReport(JSONObject jsonObject) throws Exception {
        JSONObject jsonStr = getstrObj("jsonStr", jsonObject);

        //分页参数
        String pageNum = jsonStr.getString("pageNum");
        String pageSize = jsonStr.getString("pageSize");
        Assert.notNull(pageNum, "pageNum不能为空");
        Assert.notNull(pageSize, "pageSize不能为空");

        //业务类型：TOB、TOC
        String businessType = jsonStr.getString("businessType");
        Assert.notNull(businessType, "businessType不能为空!");
        //出库日期范围
        String businessDate_start = jsonStr.getString("businessDate_start");
        String businessDate_end = jsonStr.getString("businessDate_end");
        if (businessDate_start != null) {
            businessDate_start += " 00:00:00";
        }
        if (businessDate_end != null) {
            businessDate_end += " 23:59:59";
        }
        //交易成功时间范围
        String successfulTradeDate_start = jsonStr.getString("successfulTradeDate_start");
        if (successfulTradeDate_start != null) {
            successfulTradeDate_start += " 00:00:00";
        }
        String successfulTradeDate_end = jsonStr.getString("successfulTradeDate_end");
        if (successfulTradeDate_end != null) {
            successfulTradeDate_end += " 23:59:59";
        }
        //推送时间
        String newPushDate = jsonStr.getString("newPushDate");
        String def5 = jsonStr.getString("def5");
        String def1 = jsonStr.getString("def1");
        String def3 = jsonStr.getString("def3");

        //推送状态
        String newState = jsonStr.getString("newstate");//推送状态：TOB、TOC库存同步成功
        String newState4 = jsonStr.getString("newState4");
        String newstate2 = jsonStr.getString("newstate2");
        String newstate3 = jsonStr.getString("newstate3");
        //下游系统单号、下游系统主键
        String newsystemnumber = jsonStr.getString("newsystemnumber");
        String newsystemprimary = jsonStr.getString("newsystemprimary");
        String newSystemNumber4 = jsonStr.getString("newsystemnumber4");
        String newSystemPrimary4 = jsonStr.getString("newsystemprimary4");
        String newsystemnumber2 = jsonStr.getString("newsystemnumber2");
        String newsystemprimary2 = jsonStr.getString("newsystemprimary2");
        String newsystemnumber3 = jsonStr.getString("newsystemnumber3");
        String newsystemprimary3 = jsonStr.getString("newsystemprimary3");

        TocofsSaleoutDetailedEntity tocofsSaleoutDetailedEntity = new TocofsSaleoutDetailedEntity();
        tocofsSaleoutDetailedEntity.setBusinesstype(businessType);

        tocofsSaleoutDetailedEntity.setBusinessdate_start(businessDate_start);
        tocofsSaleoutDetailedEntity.setBusinessdate_end(businessDate_end);
        tocofsSaleoutDetailedEntity.setSuccessfultradedate_start(successfulTradeDate_start);
        tocofsSaleoutDetailedEntity.setSuccessfultradedate_end(successfulTradeDate_end);

        tocofsSaleoutDetailedEntity.setNewpushdate(newPushDate);
        tocofsSaleoutDetailedEntity.setDef5(def5);
        tocofsSaleoutDetailedEntity.setDef1(def1);
        tocofsSaleoutDetailedEntity.setDef3(def3);

        tocofsSaleoutDetailedEntity.setNewstate(newState);
        tocofsSaleoutDetailedEntity.setNewstate4(newState4);
        tocofsSaleoutDetailedEntity.setNewstate2(newstate2);
        tocofsSaleoutDetailedEntity.setNewstate3(newstate3);

        tocofsSaleoutDetailedEntity.setNewsystemnumber(newsystemnumber);
        tocofsSaleoutDetailedEntity.setNewsystemprimary(newsystemprimary);
        tocofsSaleoutDetailedEntity.setNewsystemnumber4(newSystemNumber4);
        tocofsSaleoutDetailedEntity.setNewsystemprimary4(newSystemPrimary4);
        tocofsSaleoutDetailedEntity.setNewsystemnumber2(newsystemnumber2);
        tocofsSaleoutDetailedEntity.setNewsystemprimary2(newsystemprimary2);
        tocofsSaleoutDetailedEntity.setNewsystemnumber3(newsystemnumber3);
        tocofsSaleoutDetailedEntity.setNewsystemprimary3(newsystemprimary3);

        tocofsSaleoutDetailedEntity.setPageNum(Integer.valueOf(pageNum));
        tocofsSaleoutDetailedEntity.setPageSize(Integer.valueOf(pageSize));

        PageHelper.startPage(tocofsSaleoutDetailedEntity.getPageNum(), tocofsSaleoutDetailedEntity.getPageSize());
        List<TocofsSaleoutDetailedEntity> tocofsSaleoutDetailedEntityPageAttribute = iTocofsSaleoutDetailedDao.query(tocofsSaleoutDetailedEntity);
        PageInfo pageInfo = new PageInfo(tocofsSaleoutDetailedEntityPageAttribute);
        return BaseResult.getSuccessMessageEntity("查询成功", pageInfo);
    }
}
